package org.rcisoft.config;

import org.apache.poi.ss.formula.functions.T;
import org.rcisoft.core.aop.CyEntityParamAspect;
import org.rcisoft.core.aop.CyIdGenAspect;
import org.rcisoft.core.aop.CyPageUtil;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * Created by lcy on 18/1/21.
 */
@Configuration
public class CyAopConfig {


    /**
     * 分页 bean
     * @return
     */
    @Bean
    public CyPageUtil<T> pageUtil(){
        return new CyPageUtil<T>();
    }

    /**
     * id bean
     * @return
     */
    @Bean
    public CyIdGenAspect idGenAspect(){
        return new CyIdGenAspect();
    }

    /**
     *  web param validation
     * @return
     */
    @Bean
    public CyEntityParamAspect entityParamAspect(){
        return new CyEntityParamAspect();
    }
}
