package org.rcisoft.config;

import com.alibaba.druid.pool.DruidDataSource;
import org.rcisoft.core.druid.CyDruidProperties;
import org.rcisoft.core.util.CyDataSourceUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.AutoConfigureBefore;
import org.springframework.boot.autoconfigure.condition.ConditionalOnClass;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.sql.DataSource;
import java.sql.SQLException;

/**
 * @author liuzh
 * @since 2017/2/5.
 */
@Configuration
@EnableConfigurationProperties(CyDruidProperties.class)
@ConditionalOnClass(DruidDataSource.class)
@ConditionalOnProperty(prefix = "druid", name = "username")//name 随便  druid 下有对应属性即可
@AutoConfigureBefore(DataSourceAutoConfiguration.class)
//@CyDoc(CyDocEnum.USELESS)
public class CyDruidConfig {

    @Autowired
    private CyDruidProperties properties;

    @Bean
    public DataSource dataSource() {
        DruidDataSource dataSource = CyDataSourceUtil.generateDruidByPro(properties);
        try {
            dataSource.init();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
        return dataSource;
    }
}
