package org.rcisoft.config;

import org.rcisoft.core.doc.anno.CyDoc;
import org.rcisoft.core.doc.enums.CyDocEnum;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.jdbc.datasource.DataSourceTransactionManager;
import org.springframework.transaction.PlatformTransactionManager;
import org.springframework.transaction.annotation.EnableTransactionManagement;
import org.springframework.transaction.annotation.TransactionManagementConfigurer;

import javax.sql.DataSource;

/*
@Configuration
@EnableTransactionManagement
*/
@CyDoc(CyDocEnum.USELESS)
public class CyTransactionConfig implements TransactionManagementConfigurer {
    @Autowired
    @Qualifier("txManagerOracle")
    private PlatformTransactionManager txManagerOracle;

    // 创建Mysql事务管理器
    @Bean(name = "txManagerMysql")
    public PlatformTransactionManager txManagerMysql(@Qualifier("power") DataSource power) {
        return new DataSourceTransactionManager(power);
    }

    // 创建Oracle事务管理器
    @Bean(name = "txManagerOracle")
    public PlatformTransactionManager txManagerOracle(@Qualifier("pmiss") DataSource pmiss) {
        return new DataSourceTransactionManager(pmiss);
    }


    @Override
    public PlatformTransactionManager annotationDrivenTransactionManager() {
        return txManagerOracle;
    }

    /**
     * 配置事务管理器
     */
    /*@Bean
    public DataSourceTransactionManager transactionManager(CyDynamicDataSource dataSource) throws Exception {
        return new DataSourceTransactionManager(dataSource);
    }*/
}
