package org.rcisoft.core.aop;

import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.rcisoft.core.entity.CyIdEntity;
import org.rcisoft.core.util.CyIdGenUtil;

import java.util.Date;

/**
 * Created by lcy on 17/11/23.
 *
 * description:  id 构建切面
 */
@Aspect
@Slf4j
public class CyIdGenAspect {
    /**
     * 插入前  判断是否 存在id
     * @param joinPoint
     */
    @Before("execution(* org.rcisoft..*.dao.*Mapper.insert*(..))")
    public void beforeInsert(JoinPoint joinPoint){
        Object model = joinPoint.getArgs()[0];
        if(model instanceof CyIdEntity) {
            CyIdEntity idEntity = (CyIdEntity) model;
            /*id null*/
            if(StringUtils.isBlank(idEntity.getBusinessId()))
                idEntity.setBusinessId(CyIdGenUtil.uuid());
            /*create date is null*/
            if(null == idEntity.getCreateDate())
                idEntity.setCreateDate(new Date());
        }
    }
}
