package org.rcisoft.core.controller;

import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.common.component.CyGlobal;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyDateUtil;
import org.rcisoft.core.util.CyResultGenUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.util.Date;

/**
 * Created by lcy on 18/2/24.
 *
 * common
 */
@Controller("/common")
public class CyCommonController<T> extends CyFileController<T> {

    @Autowired
    private CyGlobal global;


    /**
     * 文件上传
     * @param file
     * @return
     */
    @ApiOperation(value="文件上传", notes="文件上传")
    @ApiImplicitParams({@ApiImplicitParam(name = "file", value = "文件", required = true, dataType = "file")})
    @PostMapping(value = "/upload")
    public CyResult commonFileUpload(@RequestParam("file") MultipartFile file){
        String filePath = super.globalCommonFileUpload(file, super.SAVING_PATTERN_UUID, global.getBaseUploadLocation() +
                global.getTEMP_LOCATION() + File.separator + CyDateUtil.getSimepleDate("yyyyMMdd", new Date()));
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                filePath);
    }
}
