package org.rcisoft.core.controller;

import org.rcisoft.core.result.CyResponseMessage;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.validate.CyValidatedResult;
import org.springframework.validation.BindingResult;

import java.util.Map;

/**
 * @descript validated controller
 * @author cy
 * Created by cy on 16/5/20.
 */

public class CyValidatedController extends CyHttpServletController {

    protected static final String VALIDMESSAGESKEY = "validerrors";

    private static String ERROR_PAGE = null;

    public String getErrorPage(){
        return null;
    }


    public CyValidatedController() {
    }

    /**
     * 第一版  验证写在controller里的
     * @param br
     * @return
     */
    public boolean hasErrors(BindingResult br) {
        CyValidatedResult vr = CyValidatedResult.builder(br);
        this.request.setAttribute("validerrors", vr);
        return vr.hasErrors().booleanValue();
    }

    /**
     * 第二版写在  aop里的
     * @param br
     * @return
     */
    public static boolean hasErrorsByStatic(BindingResult br) {
        CyValidatedResult vr = CyValidatedResult.builder(br);
        return vr.hasErrors().booleanValue();
    }

    public Map<String, String[]> getErrorsMap() {
        CyValidatedResult vr = (CyValidatedResult)this.request.getAttribute("validerrors");
        return vr.getErrorsMap();
    }

    public CyValidatedResult getValidatedResult() {
        CyValidatedResult vr = (CyValidatedResult)this.request.getAttribute("validerrors");
        return vr;
    }

    public CyResponseMessage getValidatedMessage() {
        CyValidatedResult vr = (CyValidatedResult)this.request.getAttribute("validerrors");
        return vr.getValidatedMessage();
    }

    protected void setBindError(BindingResult br, CyResult cyResult, String message){
        CyValidatedResult vr = CyValidatedResult.builder(br);
        cyResult.setErrorMessage(message,vr);
    }
}
