package org.rcisoft.core.result;

import lombok.Getter;

/**
 * 响应码枚举，参考HTTP状态码的语义
 */
@Getter
public enum CyResultCode {

    SUCCESS(200),//成功
    FAIL(400),//失败
    UNAUTHORIZED(401),//未认证（签名错误）
    UNAUTHENTICATED(402),//未授权(权限不够)
    NOT_FOUND(404),//接口不存在
    INTERNAL_SERVER_ERROR(500),//服务器内部错误



    PARAMETER_ERROR(601),//参数错误
    PARAMETER_DECRYPT_ERROR(603),//参数解密错误


    REDIS_OPERATE_ERROR(700),//redis 操作失败

    DATA_EXISTS(602);//数据已存在


    private int code;

    CyResultCode(int code) {
        this.code = code;
    }
}
