package org.rcisoft.core.result;

import lombok.Data;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created with family.
 * User: cy
 * Date: 16/5/20
 * Time: 下午1:45
 * description:
 */
@Data
public class CyValidatedMess implements CyResponseMessage {
    private static final long serialVersionUID = -8037198481805394212L;

    private Map<String, String[]> validMap;

    private CyValidatedMess() {
    }

    @Override
    public String getMapperKey(){
        return "validatedMessage";
    }

    private CyValidatedMess(Map<String, String[]> errorsMap){
        this.validMap = errorsMap;
    }

    public static CyValidatedMess builder(Map<String, String[]> errorsMap){
        return new CyValidatedMess(errorsMap);
    }


    private String validmessage;

    /**
     * 错误信息
     * @return
     */
    @Override
    public String getResponse(){
        List<String> list = new ArrayList<String>();
        for(Map.Entry<String,String[]> entry : this.validMap.entrySet()){
            list.add(entry.getKey() + " 异常 " +  entry.getValue()[0]);
        }
        return StringUtils.join(list,";");
    }
}
