package org.rcisoft.core.util;

import com.alibaba.druid.pool.DruidDataSource;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.mybatis.spring.SqlSessionFactoryBean;
import org.rcisoft.code.model.CodeSchema;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;

import java.io.IOException;
import java.util.Properties;

/**
 * Created with family.
 * author: cy
 * Date: 18/8/30
 * Time: 下午2:36
 * description:
 */
public class CyDbUtil {

    /**
     *  根据 schema 获取 mybatis sqlsession
      * @return
     */
    public static SqlSession getMybatisSqlSessionByCodeSchema(CodeSchema codeSchema) throws Exception {
        if(null == codeSchema)
            return null;
        Properties properties = new Properties();
        properties.setProperty("useSSL","false");
        /*druid*/
        DruidDataSource druidDataSource = new DruidDataSource();
        druidDataSource.setUrl(codeSchema.getUrl());
        druidDataSource.setUsername(codeSchema.getUsername());
        druidDataSource.setPassword(codeSchema.getPassword());
        druidDataSource.setDriverClassName(codeSchema.getDriverClass());
        druidDataSource.setConnectProperties(properties);
        /*sqlsession*/
        SqlSessionFactoryBean factoryBean = new SqlSessionFactoryBean();
        factoryBean.setDataSource(druidDataSource);
        PathMatchingResourcePatternResolver resolver = new PathMatchingResourcePatternResolver();
        factoryBean.setMapperLocations(resolver.getResources(codeSchema.getMapperLocations()));
        SqlSessionFactory factory = factoryBean.getObject();
        return  factory.openSession();
    }
}
