package org.rcisoft.core.util;


import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.result.CyResultCode;

/**
 * Created by lcy on 17/11/24.
 */
public class CyResultGenUtil {
    private static final String DEFAULT_SUCCESS_MESSAGE = "SUCCESS";


    public static CyResult builder(CyPersistModel dataModel, String sucMessage, String errMessage, Object data){
        CyResult cyResult = new CyResult();
        if(dataModel.isSuccessBySinglePersist())
            cyResult.setSucessMessage(sucMessage,data);
        else
            cyResult.setErrorMessage(errMessage,data);
        return cyResult;
    }

    public static CyResult genSuccessResult() {
        return new CyResult()
                .setCode(CyResultCode.SUCCESS)
                .setMessage(DEFAULT_SUCCESS_MESSAGE);
    }

    public static CyResult genSuccessResult(Object data) {
        return new CyResult()
                .setCode(CyResultCode.SUCCESS)
                .setMessage(DEFAULT_SUCCESS_MESSAGE)
                .setData(data);
    }

    public static CyResult genFailResult(String message) {
        return new CyResult()
                .setCode(CyResultCode.FAIL)
                .setMessage(message);
    }
}
