package org.rcisoft.sys.log.service;


import org.rcisoft.core.aop.CyPageUtil;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.sys.log.entity.SLog;

import java.util.List;

/**
 * Created by wsj on 2018-10-25 9:21:45.
 */
public interface SLogService {

    /**
    * 保存 日志表
    * @param sLog
    * @return
    */
    CyPersistModel save(SLog sLog);

    /**
    * 删除 日志表
    * @param sLog
    * @return
    */
    CyPersistModel remove(SLog sLog);

    /**
    * 逻辑删除 日志表
    * @param sLog
    * @return
    */
    CyPersistModel removeLogical(SLog sLog);

    /**
    * 修改 日志表
    * @param sLog
    * @return
    */
    CyPersistModel merge(SLog sLog);

    /**
    * 根据id查询 日志表
    * @param id
    * @return
    */
    SLog findById(String id);

    /**
    * 分页查询 日志表
    * @param sLog
    * @return
    */
    List<SLog> findAllByPagination(CyPageUtil<SLog> paginationUtility,
                                   SLog sLog);


    /**
    * 查询list 日志表
    * @param sLog
    * @return
    */
    List<SLog> findAll(SLog sLog);

}
