package org.rcisoft.sys.user.service.impl;

import org.rcisoft.core.constant.CyUserCons;
import org.rcisoft.core.exception.CyServiceException;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.result.CyResultSystemExceptionEnums;
import org.rcisoft.core.util.CyUserUtil;
import org.rcisoft.sys.user.dao.SysUserMapper;
import org.rcisoft.sys.user.entity.SysUser;
import org.rcisoft.sys.user.service.SysUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
public class SysUserServiceImpl implements SysUserService {

	@Autowired
	private SysUserMapper sysUserMapper;

	@Transactional(propagation = Propagation.REQUIRED,readOnly = false)
	@Override
	public CyPersistModel addUser(SysUser user) {
		user.setCommonBusinessId();
		//增加操作
		CyUserUtil.setCurrentPersistOperation(user);
		int line = sysUserMapper.insertSelective(user);
		return new CyPersistModel(line);
	}

	@Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
	@Override
	public CyPersistModel persistUser(SysUser user) {
		user.setCommonBusinessId();
		user.setPassword(CyUserCons.INITIAL_PASSWORD);
		int line = sysUserMapper.insertSelective(user);
		return new CyPersistModel(line);
	}

	@Override
	public void updateUser(SysUser user,String uid,int line) {
		if(!user.isEmpty()){
			user.setBusinessId(uid);
			int l1 = sysUserMapper.updateByPrimaryKeySelective(user);
			if (l1 != line)
				throw new CyServiceException(CyResultSystemExceptionEnums.FAIL);
		}
	}
}
