package ${basePackage!}.controller;


/*固定导入*/
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.controller.CyPaginationController;
import org.rcisoft.core.util.CyUserUtil;
import org.rcisoft.core.model.CyGridModel;
import org.rcisoft.core.exception.CyServiceException;
import javax.validation.Valid;


import ${basePackage!}.entity.${table.entityName!};
import ${basePackage!}.service.${table.entityName!}Service;

import java.util.List;

/**
* Created by ${author!} on ${.now}.
*/
@RestController
@RequestMapping("/${table.entityName?lower_case}")
public class ${table.entityName!}Controller extends CyPaginationController<${table.entityName!}> {

    @Autowired
    private ${table.entityName!}Service ${table.entityName?uncap_first}ServiceImpl;


    @ApiOperation(value="添加${table.tableRemark!}", notes="添加${table.tableRemark!}")
    //@ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @PostMapping(value = "/add")
    public CyResult add(@Valid ${table.entityName!} ${table.entityName?uncap_first}, BindingResult bindingResult) {
        CyPersistModel data = ${table.entityName?uncap_first}ServiceImpl.save(${table.entityName?uncap_first});
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        ${table.entityName?uncap_first});
    }

    @ApiOperation(value="逻辑删除${table.tableRemark!}", notes="逻辑删除${table.tableRemark!}")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = true, dataType = "varchar")})
    @DeleteMapping("/deleteLogical/{businessId:\\w+}")
    public CyResult deleteLogical(@PathVariable String businessId,${table.entityName!} ${table.entityName?uncap_first}) {
        ${table.entityName?uncap_first}.setBusinessId(businessId);
        CyPersistModel data = ${table.entityName?uncap_first}ServiceImpl.removeLogical(${table.entityName?uncap_first});
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        businessId);
    }

    @ApiOperation(value="删除${table.tableRemark!}", notes="删除${table.tableRemark!}")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = true, dataType = "varchar")})
    @DeleteMapping("/delete/{businessId:\\w+}")
    public CyResult delete(@PathVariable String businessId,${table.entityName!} ${table.entityName?uncap_first}) {
        ${table.entityName?uncap_first}.setBusinessId(businessId);
        CyPersistModel data = ${table.entityName?uncap_first}ServiceImpl.remove(${table.entityName?uncap_first});
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        businessId);
    }

    @ApiOperation(value="修改${table.tableRemark!}", notes="修改${table.tableRemark!}")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @PutMapping("/update/{businessId:\\w+}")
    public CyResult update(@PathVariable String businessId, @Valid ${table.entityName!} ${table.entityName?uncap_first}, BindingResult bindingResult) {
        ${table.entityName?uncap_first}.setBusinessId(businessId);
        CyPersistModel data = ${table.entityName?uncap_first}ServiceImpl.merge(${table.entityName?uncap_first});
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        ${table.entityName?uncap_first});
    }

    @ApiOperation(value="查询单一${table.tableRemark!}", notes="查询单一${table.tableRemark!}")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = true, dataType = "varchar")})
    @GetMapping("/detail/{businessId:\\w+}")
    public CyResult detail(@PathVariable String businessId) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        ${table.entityName?uncap_first}ServiceImpl.findById(businessId));
    }

    @ApiOperation(value="查询${table.tableRemark!}集合", notes="查询${table.tableRemark!}集合")
    @GetMapping(value = "/query${table.entityName!}s")
    public CyResult query${table.entityName!}s(${table.entityName!} ${table.entityName?uncap_first}) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
            ${table.entityName?uncap_first}ServiceImpl.findAll(${table.entityName?uncap_first}));
    }

    @ApiOperation(value="分页查询${table.tableRemark!}集合", notes="分页查询${table.tableRemark!}集合")
    @GetMapping(value = "/query${table.entityName!}ByPagination")
    public CyGridModel listByPagination(${table.entityName!} ${table.entityName?uncap_first}) {
        ${table.entityName?uncap_first}ServiceImpl.findAllByPagination(getPaginationUtility(), ${table.entityName?uncap_first});
        return getGridModelResponse();
    }
}
